atom/movable
	hud
		proc
			refresh(client/C)
			screen_x(var/offset="") //If offset="offset", then return the offset value.
				var
					screen_x = 1
					screen_x_offset = 0
				if(screen_loc)
					screen_x = copytext(screen_loc, 1, findtext(screen_loc, ","))
					if(findtext(screen_x,":"))
						screen_x_offset = text2num(copytext(screen_x, findtext(screen_x,":")+1))
						screen_x = text2num(copytext(screen_x, 1, findtext(screen_x,":")))
					else screen_x = text2num(screen_x)
				if(offset=="offset") return screen_x_offset
				else return screen_x
			screen_y(var/offset="") //If offset="offset", then return the offset value.
				var
					screen_y = 1
					screen_y_offset = 0
				if(screen_loc)
					screen_y = copytext(screen_loc, findtext(screen_loc, ",")+1)
					if(findtext(screen_y,":"))
						screen_y_offset = text2num(copytext(screen_y, findtext(screen_y,":")+1))
						screen_y = text2num(copytext(screen_y, 1, findtext(screen_y,":")))
					else screen_y = text2num(screen_y)
				if(offset=="offset") return screen_y_offset
				else return screen_y
		New(client/C)
			if(C) client = C
			..()
		health
			var/list/hearts = list()
			refresh(client/C)
				var/missing_hearts_count = round(C.mob.health_max/2) - length(hearts)
				for(var/i = 1, i <= missing_hearts_count, i++)
					var/atom/movable/hud/heart/H = new(C)
					hearts += H
				if(src in C.screen)
					var
						heartIndex = 0
						healthToFill = C.mob.health
					for(var/atom/movable/hud/heart/H in hearts)
						heartIndex += 1
						switch(C.HUD_type)
							if("below") H.screen_loc = num2text(heartIndex) + ",0:0"
							if("above") H.screen_loc = num2text(heartIndex) + ",NORTH+1:0"
						if(healthToFill >= 2)
							H.icon = 'heart_full.dmi'
							healthToFill -= 2
						else if(healthToFill == 1)
							H.icon = 'heart_half.dmi'
							healthToFill -= 1
						else
							H.icon = 'heart_empty.dmi'
						if(C.mob.health <= 2 && C.mob.health_max > 2)
							if(heartIndex%2) H.icon_state = "pulse1"
							else H.icon_state = "pulse2"
						else
							H.icon_state = ""
						C.screen += H
				else
					for(var/atom/movable/hud/heart/H in hearts)
						C.screen -= H
		heart
		inventory
			icon = 'hud.dmi'
			var
				max = 9
				list/inventory_slots = list()
			refresh(client/C)
				var/missing_inventory_slots_count = max - length(inventory_slots)
				for(var/i = 1, i <= missing_inventory_slots_count, i++)
					var/atom/movable/hud/inventory_slot/S = new(C)
					inventory_slots += S
				for(var/atom/movable/hud/inventory_slot/S in inventory_slots) //Count items in slots, whether slots are visible or not.
					S.item_count = 0
					for(var/atom/movable/A in C.mob)
						if(A.inventory_slot == S)
							S.item_count += 1
							S.icon = A.icon
					if(S.item_count <= 0)
						S.icon = null
				if(src in C.screen)
					var
						screen_x = screen_x()
						screen_y = screen_y()
						screen_x_offset = screen_x("offset")
						screen_y_offset = screen_y("offset")
						i = 0
					for(var/atom/movable/hud/inventory_slot/S in inventory_slots)
						i += 1
						var/dx = screen_x_offset + (i-1)*(world.icon_size-6)
						S.screen_loc = "[screen_x]:[dx],[screen_y]:[screen_y_offset]"
						C.screen += S
				else
					for(var/atom/movable/hud/inventory_slot/S in inventory_slots)
						C.screen -= S
				C.HUD_selector.refresh(C)
		inventory_slot
			var
				item_count = 0 //Keep track of how many items are currently stored in this slot.
		selector
			icon = 'selector_box.dmi'
			var/atom/movable/hud/inventory_slot/target_slot = null
			refresh(client/C)
				var/list/slots = C.HUD_inventory.inventory_slots
				for(var/atom/movable/hud/inventory_slot/S in slots)
					if(!target_slot)
						target_slot = S
				screen_loc = target_slot.screen_loc
				if(C.HUD_inventory in C.screen)
					C.screen += src
				else
					C.screen -= src