client
	var
		HUD_type	//Keep track of how HUD (inventory, health, etc) is displayed. Zero means HUD is not displayed.
		atom/movable/hud/health/HUD_health
		atom/movable/hud/inventory/HUD_inventory
		atom/movable/hud/selector/HUD_selector
	New()
		HUD_health = new/atom/movable/hud/health(src)
		HUD_inventory = new/atom/movable/hud/inventory(src)
		HUD_selector = new/atom/movable/hud/selector(src)
		HUD_refresh()
		..()
	proc
		HUD_refresh()
			switch(HUD_type)
				if("below")
					HUD_health.screen_loc = "1,0"
					var/dx = num2text(round(ViewWidth()/2) - round(HUD_inventory.iconWidth()/2))
					HUD_inventory.screen_loc = "1:[dx],0:0"
					screen += HUD_health
					screen += HUD_inventory
				if("above")
					HUD_health.screen_loc = "1,NORTH+1"
					var/dx = num2text(round(ViewWidth()/2) - round(HUD_inventory.iconWidth()/2))
					HUD_inventory.screen_loc = "1:[dx],NORTH+1:0"
					screen += HUD_health
					screen += HUD_inventory
				else
					screen -= HUD_health
					screen -= HUD_inventory
			HUD_health.refresh(src)
			HUD_inventory.refresh(src)
			HUD_selector.refresh(src)