client
	var
		north = 0	//Keep track of movement key presses.
		east = 0
		south = 0
		west = 0
	North() keyboard("North") //Key pressed down
	East()  keyboard("East")
	South() keyboard("South")
	West()  keyboard("West")
	Northeast() keyboard("Northeast")
	Northwest() keyboard("Northwest")
	Southeast() keyboard("Southeast")
	Southwest() keyboard("Southwest")
	verb
		A() keyboard("A") //Key pressed down
		B() keyboard("B")
		C() keyboard("C")
		D() keyboard("D")
		E() keyboard("E")
		F() keyboard("F")
		G() keyboard("G")
		H() keyboard("H")
		I() keyboard("I")
		J() keyboard("J")
		K() keyboard("K")
		L() keyboard("L")
		M() keyboard("M")
		N() keyboard("N")
		O() keyboard("O")
		P() keyboard("P")
		Q() keyboard("Q")
		R() keyboard("R")
		S() keyboard("S")
		T() keyboard("T")
		U() keyboard("U")
		V() keyboard("V")
		W() keyboard("W")
		X() keyboard("X")
		Y() keyboard("Y")
		Z() keyboard("Z")
		Escape() keyboard("Escape")
		Return() keyboard("Return")
		Space() keyboard("Space")
		AUP() keyboard("A",up=TRUE) //Key released
		BUP() keyboard("B",up=TRUE)
		CUP() keyboard("C",up=TRUE)
		DUP() keyboard("D",up=TRUE)
		EUP() keyboard("E",up=TRUE)
		FUP() keyboard("F",up=TRUE)
		GUP() keyboard("G",up=TRUE)
		HUP() keyboard("H",up=TRUE)
		IUP() keyboard("I",up=TRUE)
		JUP() keyboard("J",up=TRUE)
		KUP() keyboard("K",up=TRUE)
		LUP() keyboard("L",up=TRUE)
		MUP() keyboard("M",up=TRUE)
		NUP() keyboard("N",up=TRUE)
		OUP() keyboard("O",up=TRUE)
		PUP() keyboard("P",up=TRUE)
		QUP() keyboard("Q",up=TRUE)
		RUP() keyboard("R",up=TRUE)
		SUP() keyboard("S",up=TRUE)
		TUP() keyboard("T",up=TRUE)
		UUP() keyboard("U",up=TRUE)
		VUP() keyboard("V",up=TRUE)
		WUP() keyboard("W",up=TRUE)
		XUP() keyboard("X",up=TRUE)
		YUP() keyboard("Y",up=TRUE)
		ZUP() keyboard("Z",up=TRUE)
		EscapeUP() keyboard("Escape",up=TRUE)
		ReturnUP() keyboard("Return",up=TRUE)
		SpaceUP() keyboard("Space",up=TRUE)
		NorthUP() keyboard("North",up=TRUE)
		EastUP()  keyboard("East",up=TRUE)
		SouthUP() keyboard("South",up=TRUE)
		WestUP()  keyboard("West",up=TRUE)
		Numpad2UP() keyboard("Numpad2",up=TRUE)
		Numpad4UP() keyboard("Numpad4",up=TRUE)
		Numpad6UP() keyboard("Numpad6",up=TRUE)
		Numpad8UP() keyboard("Numpad8",up=TRUE)
		keyboard(var/keypress=null as text,var/up=FALSE as num)
			switch(state) //Use client's state to determine what a key press should do.
				if(MOVE) switch(keypress) //Once state is determined, then interpret the keypress.
					if("North")
						if(!up) GapNudge_North()
						else	GapNudge_NorthReleased()
					if("East")
						if(!up) GapNudge_East()
						else	GapNudge_EastReleased()
					if("South")
						if(!up) GapNudge_South()
						else	GapNudge_SouthReleased()
					if("West")
						if(!up) GapNudge_West()
						else	GapNudge_WestReleased()
					if("Northeast") GapNudge_Northeast()
					if("Northwest") GapNudge_Northwest()
					if("Southeast") GapNudge_Southeast()
					if("Southwest") GapNudge_Southwest()
					if("A") keyboard("West",up)
					if("D") keyboard("East",up)
					if("S") keyboard("South",up)
					if("W") keyboard("North",up)
					if("Numpad2") if(up) keyboard("South",up)
					if("Numpad4") if(up) keyboard("West",up)
					if("Numpad6") if(up) keyboard("East",up)
					if("Numpad8") if(up) keyboard("North",up)
				if(JUMP) switch(keypress) //Once state is determined, then interpret the keypress.
					if("East") if(!up) Platformer_East()
					if("South") if(!up) Platformer_South()
					if("West") if(!up) Platformer_West()
					if("A") if(!up) Platformer_West()
					if("D") if(!up) Platformer_East()
					if("S") if(!up) Platformer_South()
					if("Numpad2") if(!up) Platformer_South()
					if("Numpad4") if(!up) Platformer_West()
					if("Numpad6") if(!up) Platformer_East()
					if("Space")
						if(!up) Jump()
						else JumpReleased()
				if(HUD_WINDOW) switch(keypress) //Once state is determined, then interpret the keypress.
					if("Space","Return")
						if(!up)
							for(var/atom/movable/hud/window/W in screen)
								del W
							previous_state()
				if(MENU) switch(keypress) //Once state is determined, then interpret the keypress.
					if("North")
						if(!up)	Menu_North()
						else	Menu_NorthReleased()
					if("East")
						if(!up) Menu_East()
						else	Menu_EastReleased()
					if("South")
						if(!up) Menu_South()
						else	Menu_SouthReleased()
					if("West")
						if(!up) Menu_West()
						else	Menu_WestReleased()
					if("A") keyboard("West",up)
					if("D") keyboard("East",up)
					if("S") keyboard("South",up)
					if("W") keyboard("North",up)
					if("Numpad2") if(up) keyboard("South",up)
					if("Numpad4") if(up) keyboard("West",up)
					if("Numpad6") if(up) keyboard("East",up)
					if("Numpad8") if(up) keyboard("North",up)
					if("Space","Return")
						if(!up)
							mob << sound('coin2.wav', volume=60)
							menuOption.activate(src)
							menuOption = null